osgUtil::CullVisitor Class Reference

`#include <CullVisitor>`

Inheritance diagram for osgUtil::CullVisitor:

## Classes

struct | Identifier
struct | MatrixPlanesDrawables

## Public Types

typedef osg::Matrix::value_type | value_type
Public Types inherited from osg::NodeVisitor
enum | TraversalMode { TRAVERSE_NONE , TRAVERSE_PARENTS , TRAVERSE_ALL_CHILDREN , TRAVERSE_ACTIVE_CHILDREN }
enum | VisitorType { NODE_VISITOR = 0 , UPDATE_VISITOR , EVENT_VISITOR , COLLECT_OCCLUDER_VISITOR , CULL_VISITOR , INTERSECTION_VISITOR }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Public Types inherited from osg::CullStack
typedef std::vector< ShadowVolumeOccluder > | OccluderList
typedef std::vector< CullingSet > | CullingStack
typedef fast_back_stack< ref_ptr< RefMatrix > > | MatrixStack
Public Types inherited from osg::CullSettings

enum

VariablesMask {
COMPUTE_NEAR_FAR_MODE = (0x1 << 0) , CULLING_MODE = (0x1 << 1) , LOD_SCALE = (0x1 << 2) , SMALL_FEATURE_CULLING_PIXEL_SIZE = (0x1 << 3) ,
CLAMP_PROJECTION_MATRIX_CALLBACK = (0x1 << 4) , NEAR_FAR_RATIO = (0x1 << 5) , IMPOSTOR_ACTIVE = (0x1 << 6) , DEPTH_SORT_IMPOSTOR_SPRITES = (0x1 << 7) ,
IMPOSTOR_PIXEL_ERROR_THRESHOLD = (0x1 << 8) , NUM_FRAMES_TO_KEEP_IMPOSTORS_SPRITES = (0x1 << 9) , CULL_MASK = (0x1 << 10) , CULL_MASK_LEFT = (0x1 << 11) ,
CULL_MASK_RIGHT = (0x1 << 12) , CLEAR_COLOR = (0x1 << 13) , CLEAR_MASK = (0x1 << 14) , LIGHTING_MODE = (0x1 << 15) ,
LIGHT = (0x1 << 16) , DRAW_BUFFER = (0x1 << 17) , READ_BUFFER = (0x1 << 18) , NO_VARIABLES = 0x00000000 ,
ALL_VARIABLES = 0x7FFFFFFF
}

enum | InheritanceMaskActionOnAttributeSetting { DISABLE_ASSOCIATED_INHERITANCE_MASK_BIT , DO_NOT_MODIFY_INHERITANCE_MASK }
enum | ComputeNearFarMode { DO_NOT_COMPUTE_NEAR_FAR = 0 , COMPUTE_NEAR_FAR_USING_BOUNDING_VOLUMES , COMPUTE_NEAR_FAR_USING_PRIMITIVES , COMPUTE_NEAR_USING_PRIMITIVES }
enum | CullingModeValues { NO_CULLING = 0x0 , VIEW_FRUSTUM_SIDES_CULLING = 0x1 , NEAR_PLANE_CULLING = 0x2 , FAR_PLANE_CULLING = 0x4 , VIEW_FRUSTUM_CULLING , SMALL_FEATURE_CULLING = 0x8 , SHADOW_OCCLUSION_CULLING = 0x10 , CLUSTER_CULLING = 0x20 , DEFAULT_CULLING , ENABLE_ALL_CULLING }
typedef int | InheritanceMask
typedef int | CullingMode

## Public Member Functions

| CullVisitor ()
| CullVisitor (const CullVisitor &)
| Copy constructor that does a shallow copy.
| META_NodeVisitor (osgUtil, CullVisitor) virtual osgUtil
virtual const osgUtil::CullVisitor * | asCullVisitor () const
virtual osg::CullStack * | asCullStack ()
virtual const osg::CullStack * | asCullStack () const
virtual CullVisitor * | clone () const
virtual void | reset ()
void | setIdentifier (Identifier *identifier)
Identifier * | getIdentifier ()
const Identifier * | getIdentifier () const
virtual osg::Vec3 | getEyePoint () const
virtual osg::Vec3 | getViewPoint () const
virtual float | getDistanceToEyePoint (const osg::Vec3 &pos, bool withLODScale) const
virtual float | getDistanceFromEyePoint (const osg::Vec3 &pos, bool withLODScale) const
virtual float | getDistanceToViewPoint (const osg::Vec3 &pos, bool withLODScale) const
virtual void | apply (osg::Node &)
virtual void | apply (osg::Geode &node)
virtual void | apply (osg::Drawable &drawable)
virtual void | apply (osg::Billboard &node)
virtual void | apply (osg::LightSource &node)
virtual void | apply (osg::ClipNode &node)
virtual void | apply (osg::TexGenNode &node)
virtual void | apply (osg::Group &node)
virtual void | apply (osg::Transform &node)
virtual void | apply (osg::Projection &node)
virtual void | apply (osg::Switch &node)
virtual void | apply (osg::LOD &node)
virtual void | apply (osg::ClearNode &node)
virtual void | apply (osg::Camera &node)
virtual void | apply (osg::OccluderNode &node)
virtual void | apply (osg::OcclusionQueryNode &node)
void | pushStateSet (const osg::StateSet *ss)
void | popStateSet ()
void | setStateGraph (StateGraph *rg)
StateGraph * | getRootStateGraph ()
StateGraph * | getCurrentStateGraph ()
void | setRenderStage (RenderStage *rg)
RenderStage * | getRenderStage ()
RenderStage * | getCurrentRenderStage ()
osg::Camera * | getCurrentCamera ()
RenderBin * | getCurrentRenderBin ()
void | setCurrentRenderBin (RenderBin *rb)
void | setCalculatedNearPlane (value_type value)
value_type | getCalculatedNearPlane () const
void | setCalculatedFarPlane (value_type value)
value_type | getCalculatedFarPlane () const
value_type | computeNearestPointInFrustum (const osg::Matrix &matrix, const osg::Polytope::PlaneList &planes, const osg::Drawable &drawable)
value_type | computeFurthestPointInFrustum (const osg::Matrix &matrix, const osg::Polytope::PlaneList &planes, const osg::Drawable &drawable)
bool | updateCalculatedNearFar (const osg::Matrix &matrix, const osg::BoundingBox &bb)
bool | updateCalculatedNearFar (const osg::Matrix &matrix, const osg::Drawable &drawable, bool isBillboard=false)
void | updateCalculatedNearFar (const osg::Vec3 &pos)
void | addDrawable (osg::Drawable *drawable, osg::RefMatrix *matrix)
void | addDrawableAndDepth (osg::Drawable *drawable, osg::RefMatrix *matrix, float depth)
void | addPositionedAttribute (osg::RefMatrix *matrix, const osg::StateAttribute *attr)
void | addPositionedTextureAttribute (unsigned int textureUnit, osg::RefMatrix *matrix, const osg::StateAttribute *attr)
void | computeNearPlane ()
virtual void | popProjectionMatrix ()
virtual bool | clampProjectionMatrixImplementation (osg::Matrixf &projection, double &znear, double &zfar) const
virtual bool | clampProjectionMatrixImplementation (osg::Matrixd &projection, double &znear, double &zfar) const
bool | clampProjectionMatrix (osg::Matrixf &projection, value_type &znear, value_type &zfar) const
bool | clampProjectionMatrix (osg::Matrixd &projection, value_type &znear, value_type &zfar) const
void | setState (osg::State *state)
osg::State * | getState ()
const osg::State * | getState () const
void | setRenderInfo (osg::RenderInfo &renderInfo)
osg::RenderInfo & | getRenderInfo ()
const osg::RenderInfo & | getRenderInfo () const
Public Member Functions inherited from osg::NodeVisitor
| NodeVisitor (TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (VisitorType type, TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (const NodeVisitor &nv, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~NodeVisitor ()
| META_Object (osg, NodeVisitor) virtual NodeVisitor *asNodeVisitor()
virtual const NodeVisitor * | asNodeVisitor () const
virtual osgUtil::UpdateVisitor * | asUpdateVisitor ()
virtual const osgUtil::UpdateVisitor * | asUpdateVisitor () const
virtual osgUtil::CullVisitor * | asCullVisitor ()
virtual osgGA::EventVisitor * | asEventVisitor ()
virtual const osgGA::EventVisitor * | asEventVisitor () const
virtual osgUtil::IntersectionVisitor * | asIntersectionVisitor ()
virtual const osgUtil::IntersectionVisitor * | asIntersectionVisitor () const
void | setVisitorType (VisitorType type)
VisitorType | getVisitorType () const
void | setTraversalNumber (unsigned int fn)
unsigned int | getTraversalNumber () const
void | setFrameStamp (FrameStamp *fs)
const FrameStamp * | getFrameStamp () const
void | setTraversalMask (Node::NodeMask mask)
Node::NodeMask | getTraversalMask () const
void | setNodeMaskOverride (Node::NodeMask mask)
Node::NodeMask | getNodeMaskOverride () const
bool | validNodeMask (const osg::Node &node) const
void | setTraversalMode (TraversalMode mode)
TraversalMode | getTraversalMode () const
void | setValueMap (ValueMap *ps)
ValueMap * | getValueMap ()
const ValueMap * | getValueMap () const
ValueMap * | getOrCreateValueMap ()
void | setValueStack (ValueStack *ps)
ValueStack * | getValueStack ()
const ValueStack * | getValueStack () const
ValueStack * | getOrCreateValueStack ()
void | traverse (Node &node)
void | pushOntoNodePath (Node *node)
void | popFromNodePath ()
NodePath & | getNodePath ()
const NodePath & | getNodePath () const
virtual void | apply (Geometry &geometry)
virtual void | apply (ProxyNode &node)
virtual void | apply (CoordinateSystemNode &node)
virtual void | apply (CameraView &node)
virtual void | apply (MatrixTransform &node)
virtual void | apply (PositionAttitudeTransform &node)
virtual void | apply (AutoTransform &node)
virtual void | apply (Sequence &node)
virtual void | apply (PagedLOD &node)
void | setDatabaseRequestHandler (DatabaseRequestHandler *handler)
DatabaseRequestHandler * | getDatabaseRequestHandler ()
const DatabaseRequestHandler * | getDatabaseRequestHandler () const
void | setImageRequestHandler (ImageRequestHandler *handler)
ImageRequestHandler * | getImageRequestHandler ()
const ImageRequestHandler * | getImageRequestHandler () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::CullStack
| CullStack ()
| CullStack (const CullStack &cs)
| ~CullStack ()
void | reset ()
void | pushCullingSet ()
void | popCullingSet ()
void | setOccluderList (const ShadowVolumeOccluderList &svol)
ShadowVolumeOccluderList & | getOccluderList ()
const ShadowVolumeOccluderList & | getOccluderList () const
void | pushViewport (osg::Viewport *viewport)
void | popViewport ()
void | pushProjectionMatrix (osg::RefMatrix *matrix)
void | popProjectionMatrix ()
void | pushModelViewMatrix (osg::RefMatrix *matrix, Transform::ReferenceFrame referenceFrame)
void | popModelViewMatrix ()
float | getFrustumVolume ()
float | pixelSize (const Vec3 &v, float radius) const
float | pixelSize (const BoundingSphere &bs) const
float | clampedPixelSize (const Vec3 &v, float radius) const
float | clampedPixelSize (const BoundingSphere &bs) const
void | disableAndPushOccludersCurrentMask (NodePath &nodePath)
void | popOccludersCurrentMask (NodePath &nodePath)
bool | isCulled (const std::vector< Vec3 > &vertices)
bool | isCulled (const BoundingBox &bb)
bool | isCulled (const BoundingSphere &bs)
bool | isCulled (const osg::Node &node)
void | pushCurrentMask ()
void | popCurrentMask ()
CullingStack & | getClipSpaceCullingStack ()
CullingStack & | getProjectionCullingStack ()
CullingStack & | getModelViewCullingStack ()
CullingSet & | getCurrentCullingSet ()
const CullingSet & | getCurrentCullingSet () const
osg::Viewport * | getViewport ()
const osg::Viewport * | getViewport () const
osg::RefMatrix * | getModelViewMatrix ()
const osg::RefMatrix * | getModelViewMatrix () const
osg::RefMatrix * | getProjectionMatrix ()
const osg::RefMatrix * | getProjectionMatrix () const
osg::Matrix | getWindowMatrix () const
const osg::RefMatrix * | getMVPW ()
const osg::Vec3 & | getReferenceViewPoint () const
void | pushReferenceViewPoint (const osg::Vec3 &viewPoint)
void | popReferenceViewPoint ()
const osg::Vec3 & | getEyeLocal () const
const osg::Vec3 & | getViewPointLocal () const
const osg::Vec3 | getUpLocal () const
const osg::Vec3 | getLookVectorLocal () const
MatrixStack & | getProjectionStack ()
const MatrixStack & | getProjectionStack () const
MatrixStack & | getModelViewStack ()
const MatrixStack & | getModelViewStack () const
MatrixStack & | getMVPWStack ()
const MatrixStack & | getMVPWStack () const
Public Member Functions inherited from osg::CullSettings
| CullSettings ()
| CullSettings (ArgumentParser &arguments)
| CullSettings (const CullSettings &cs)
virtual | ~CullSettings ()
CullSettings & | operator= (const CullSettings &settings)
virtual void | setDefaults ()
void | setInheritanceMask (InheritanceMask mask)
InheritanceMask | getInheritanceMask () const
void | setCullSettings (const CullSettings &settings)
virtual void | inheritCullSettings (const CullSettings &settings)
virtual void | inheritCullSettings (const CullSettings &settings, unsigned int inheritanceMask)
void | readEnvironmentalVariables ()
void | readCommandLine (ArgumentParser &arguments)
void | setInheritanceMaskActionOnAttributeSetting (InheritanceMaskActionOnAttributeSetting action)
InheritanceMaskActionOnAttributeSetting | getInheritanceMaskActionOnAttributeSetting () const
void | applyMaskAction (unsigned int maskBit)
void | setImpostorsActive (bool active)
bool | getImpostorsActive () const
void | setImpostorPixelErrorThreshold (float numPixels)
float | getImpostorPixelErrorThreshold () const
void | setDepthSortImpostorSprites (bool doDepthSort)
bool | getDepthSortImpostorSprites () const
void | setNumberOfFrameToKeepImpostorSprites (int numFrames)
int | getNumberOfFrameToKeepImpostorSprites () const
void | setComputeNearFarMode (ComputeNearFarMode cnfm)
ComputeNearFarMode | getComputeNearFarMode () const
void | setNearFarRatio (double ratio)
double | getNearFarRatio () const
void | setCullingMode (CullingMode mode)
CullingMode | getCullingMode () const
void | setCullMask (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMask () const
void | setCullMaskLeft (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMaskLeft () const
void | setCullMaskRight (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMaskRight () const
void | setLODScale (float scale)
float | getLODScale () const
void | setSmallFeatureCullingPixelSize (float value)
float | getSmallFeatureCullingPixelSize () const
void | setClampProjectionMatrixCallback (ClampProjectionMatrixCallback *cpmc)
ClampProjectionMatrixCallback * | getClampProjectionMatrixCallback ()
const ClampProjectionMatrixCallback * | getClampProjectionMatrixCallback () const
void | write (std::ostream &out)

## Static Public Member Functions

static osg::ref_ptr< CullVisitor > & | prototype ()
static CullVisitor * | create ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef std::vector< osg::ref_ptr< RenderLeaf > > | RenderLeafList
typedef std::multimap< value_type, MatrixPlanesDrawables > | DistanceMatrixDrawableMap
Protected Types inherited from osg::CullStack
typedef fast_back_stack< ref_ptr< Viewport > > | ViewportStack
typedef fast_back_stack< Vec3 > | EyePointStack
typedef std::vector< osg::ref_ptr< osg::RefMatrix > > | MatrixList

## Protected Member Functions

virtual | ~CullVisitor ()
CullVisitor & | operator= (const CullVisitor &)
void | handle_cull_callbacks_and_traverse (osg::Node &node)
void | handle_cull_callbacks_and_accept (osg::Node &node, osg::Node *acceptNode)
RenderLeaf * | createOrReuseRenderLeaf (osg::Drawable *drawable, osg::RefMatrix *projection, osg::RefMatrix *matrix, float depth=0.0f)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Member Functions inherited from osg::CullStack
void | computeFrustumVolume ()
osg::RefMatrix * | createOrReuseMatrix (const osg::Matrix &value)

## Protected Attributes

osg::ref_ptr< StateGraph > | _rootStateGraph
StateGraph * | _currentStateGraph
osg::ref_ptr< RenderStage > | _rootRenderStage
RenderBin * | _currentRenderBin
std::vector< RenderBin * > | _renderBinStack
value_type | _computed_znear
value_type | _computed_zfar
unsigned int | _traversalOrderNumber
RenderLeafList | _reuseRenderLeafList
unsigned int | _currentReuseRenderLeafIndex
unsigned int | _numberOfEncloseOverrideRenderBinDetails
osg::RenderInfo | _renderInfo
DistanceMatrixDrawableMap | _nearPlaneCandidateMap
DistanceMatrixDrawableMap | _farPlaneCandidateMap
osg::ref_ptr< Identifier > | _identifier
Protected Attributes inherited from osg::NodeVisitor
VisitorType | _visitorType
unsigned int | _traversalNumber
ref_ptr< FrameStamp > | _frameStamp
TraversalMode | _traversalMode
Node::NodeMask | _traversalMask
Node::NodeMask | _nodeMaskOverride
NodePath | _nodePath
ref_ptr< DatabaseRequestHandler > | _databaseRequestHandler
ref_ptr< ImageRequestHandler > | _imageRequestHandler
osg::ref_ptr< ValueMap > | _valueMap
osg::ref_ptr< ValueStack > | _valueStack
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount
Protected Attributes inherited from osg::CullStack
ShadowVolumeOccluderList | _occluderList
MatrixStack | _projectionStack
MatrixStack | _modelviewStack
MatrixStack | _MVPW_Stack
ViewportStack | _viewportStack
EyePointStack | _referenceViewPoints
EyePointStack | _eyePointStack
EyePointStack | _viewPointStack
CullingStack | _clipspaceCullingStack
CullingStack | _projectionCullingStack
CullingStack | _modelviewCullingStack
unsigned int | _index_modelviewCullingStack
CullingSet * | _back_modelviewCullingStack
float | _frustumVolume
unsigned int | _bbCornerNear
unsigned int | _bbCornerFar
ref_ptr< osg::RefMatrix > | _identity
MatrixList | _reuseMatrixList
unsigned int | _currentReuseMatrixIndex
Protected Attributes inherited from osg::CullSettings
InheritanceMask | _inheritanceMask
InheritanceMaskActionOnAttributeSetting | _inheritanceMaskActionOnAttributeSetting
ComputeNearFarMode | _computeNearFar
CullingMode | _cullingMode
float | _LODScale
float | _smallFeatureCullingPixelSize
ref_ptr< ClampProjectionMatrixCallback > | _clampProjectionMatrixCallback
double | _nearFarRatio
bool | _impostorActive
bool | _depthSortImpostorSprites
float | _impostorPixelErrorThreshold
int | _numFramesToKeepImpostorSprites
Node::NodeMask | _cullMask
Node::NodeMask | _cullMaskLeft
Node::NodeMask | _cullMaskRight

## Detailed Description

Basic NodeVisitor implementation for rendering a scene. This visitor traverses the scene graph, collecting transparent and opaque osg::Drawables into a depth sorted transparent bin and a state sorted opaque bin. The opaque bin is rendered first, and then the transparent bin is rendered in order from the furthest osg::Drawable from the eye to the one nearest the eye.

## Member Typedef Documentation

## DistanceMatrixDrawableMap

typedef std::multimap<value_type, MatrixPlanesDrawables> osgUtil::CullVisitor::DistanceMatrixDrawableMap

protected

## RenderLeafList

typedef std::vector< osg::ref_ptr<RenderLeaf> > osgUtil::CullVisitor::RenderLeafList

protected

## value_type

typedef osg::Matrix::value_type osgUtil::CullVisitor::value_type

## Constructor & Destructor Documentation

## CullVisitor() [1/2]

osgUtil::CullVisitor::CullVisitor | ( |  | ) |

Referenced by clone(), create(), CullVisitor(), META_NodeVisitor(), and operator=().

## CullVisitor() [2/2]

osgUtil::CullVisitor::CullVisitor | ( | const CullVisitor & |  | ) |

Copy constructor that does a shallow copy.

References CullVisitor().

## ~CullVisitor()

virtual osgUtil::CullVisitor::~CullVisitor | ( |  | ) |

protected virtual

## Member Function Documentation

## addDrawable()

void osgUtil::CullVisitor::addDrawable | ( | osg::Drawable * | drawable,
|  | osg::RefMatrix * | matrix )

inline

Add a drawable to current render graph.

References _currentRenderBin, _currentStateGraph, osg::CullStack::_projectionStack, and createOrReuseRenderLeaf().

Referenced by updateCalculatedNearFar().

## addDrawableAndDepth()

void osgUtil::CullVisitor::addDrawableAndDepth | ( | osg::Drawable * | drawable,
|  | osg::RefMatrix * | matrix,
|  | float | depth )

inline

Add a drawable and depth to current render graph.

References _currentRenderBin, _currentStateGraph, osg::CullStack::_projectionStack, and createOrReuseRenderLeaf().

Referenced by updateCalculatedNearFar().

## addPositionedAttribute()

void osgUtil::CullVisitor::addPositionedAttribute | ( | osg::RefMatrix * | matrix,
|  | const osg::StateAttribute * | attr )

inline

Add an attribute which is positioned relative to the modelview matrix.

References _currentRenderBin.

Referenced by updateCalculatedNearFar().

## addPositionedTextureAttribute()

void osgUtil::CullVisitor::addPositionedTextureAttribute | ( | unsigned int | textureUnit,
|  | osg::RefMatrix * | matrix,
|  | const osg::StateAttribute * | attr )

inline

Add an attribute which is positioned relative to the modelview matrix.

References _currentRenderBin.

Referenced by updateCalculatedNearFar().

## apply() [1/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Billboard & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [2/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Camera & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [3/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::ClearNode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [4/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::ClipNode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [5/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Drawable & | drawable | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [6/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Geode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [7/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Group & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [8/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::LightSource & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [9/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::LOD & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [10/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Node & |  | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [11/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::OccluderNode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [12/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::OcclusionQueryNode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [13/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Projection & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [14/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Switch & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [15/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::TexGenNode & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [16/16]

virtual void osgUtil::CullVisitor::apply | ( | osg::Transform & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## asCullStack() [1/2]

virtual osg::CullStack * osgUtil::CullVisitor::asCullStack | ( |  | ) |

inline virtual

Convert 'this' into a osg::CullStack pointer if Object is a osg::CullStack, otherwise return 0. Equivalent to dynamic_cast<osg::CullStack*>(this).

Reimplemented from osg::NodeVisitor.

## asCullStack() [2/2]

virtual const osg::CullStack * osgUtil::CullVisitor::asCullStack | ( |  | ) | const

inline virtual

convert 'const this' into a const osg::CullStack pointer if Object is a osg::CullStack, otherwise return 0. Equivalent to dynamic_cast<const osg::CullStack*>(this).

Reimplemented from osg::NodeVisitor.

## asCullVisitor()

virtual const osgUtil::CullVisitor * osgUtil::CullVisitor::asCullVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const osgUtil::CullVisitor pointer if Object is a osgUtil::CullVisitor, otherwise return 0. Equivalent to dynamic_cast<const osgUtil::CullVisitor*>(this).

Reimplemented from osg::NodeVisitor.

Referenced by META_NodeVisitor().

## clampProjectionMatrix() [1/2]

bool osgUtil::CullVisitor::clampProjectionMatrix | ( | osg::Matrixd & | projection,
|  | value_type & | znear,
|  | value_type & | zfar ) const

inline

Clamp the projection double matrix to computed near and far values, use callback if it exists, otherwise use default CullVisitor implementation.

References osg::CullSettings::_clampProjectionMatrixCallback, and clampProjectionMatrixImplementation().

## clampProjectionMatrix() [2/2]

bool osgUtil::CullVisitor::clampProjectionMatrix | ( | osg::Matrixf & | projection,
|  | value_type & | znear,
|  | value_type & | zfar ) const

inline

Clamp the projection float matrix to computed near and far values, use callback if it exists, otherwise use default CullVisitor implementation.

References osg::CullSettings::_clampProjectionMatrixCallback, and clampProjectionMatrixImplementation().

## clampProjectionMatrixImplementation() [1/2]

virtual bool osgUtil::CullVisitor::clampProjectionMatrixImplementation | ( | osg::Matrixd & | projection,
|  | double & | znear,
|  | double & | zfar ) const

virtual

CullVisitor's default clamping of the projection double matrix to computed near and far values. Note, do not call this method directly, use clampProjectionMatrix(..) instead, unless you want to bypass the callback.

## clampProjectionMatrixImplementation() [2/2]

virtual bool osgUtil::CullVisitor::clampProjectionMatrixImplementation | ( | osg::Matrixf & | projection,
|  | double & | znear,
|  | double & | zfar ) const

virtual

CullVisitor's default clamping of the projection float matrix to computed near and far values. Note, do not call this method directly, use clampProjectionMatrix(..) instead, unless you want to bypass the callback.

Referenced by clampProjectionMatrix(), and clampProjectionMatrix().

## clone()

virtual CullVisitor * osgUtil::CullVisitor::clone | ( |  | ) | const

inline virtual

Create a shallow copy of the CullVisitor, used by CullVisitor::create() to clone the prototype.

References CullVisitor().

## computeFurthestPointInFrustum()

value_type osgUtil::CullVisitor::computeFurthestPointInFrustum | ( | const osg::Matrix & | matrix,
|  | const osg::Polytope::PlaneList & | planes,
|  | const osg::Drawable & | drawable )

## computeNearestPointInFrustum()

value_type osgUtil::CullVisitor::computeNearestPointInFrustum | ( | const osg::Matrix & | matrix,
|  | const osg::Polytope::PlaneList & | planes,
|  | const osg::Drawable & | drawable )

## computeNearPlane()

void osgUtil::CullVisitor::computeNearPlane | ( |  | ) |

compute near plane based on the polgon intersection of primtives in near plane candidate list of drawables. Note, you have to set ComputeNearFarMode to COMPUTE_NEAR_FAR_USING_PRIMITIVES to be able to near plane candidate drawables to be recorded by the cull traversal.

## create()

CullVisitor * osgUtil::CullVisitor::create | ( |  | ) |

static

create a CullVisitor by cloning CullVisitor::prototype().

References CullVisitor().

## createOrReuseRenderLeaf()

RenderLeaf * osgUtil::CullVisitor::createOrReuseRenderLeaf | ( | osg::Drawable * | drawable,
|  | osg::RefMatrix * | projection,
|  | osg::RefMatrix * | matrix,
|  | float | depth = 0.0f )

inline protected

References _currentReuseRenderLeafIndex, _reuseRenderLeafList, _traversalOrderNumber, osg::INFO, osg::notify(), and osgUtil::RenderLeaf::set().

Referenced by addDrawable(), and addDrawableAndDepth().

## getCalculatedFarPlane()

value_type osgUtil::CullVisitor::getCalculatedFarPlane | ( |  | ) | const

inline

References _computed_zfar.

## getCalculatedNearPlane()

value_type osgUtil::CullVisitor::getCalculatedNearPlane | ( |  | ) | const

inline

References _computed_znear.

## getCurrentCamera()

osg::Camera * osgUtil::CullVisitor::getCurrentCamera | ( |  | ) |

inline

References getCurrentRenderStage().

## getCurrentRenderBin()

RenderBin * osgUtil::CullVisitor::getCurrentRenderBin | ( |  | ) |

inline

References _currentRenderBin.

## getCurrentRenderStage()

RenderStage * osgUtil::CullVisitor::getCurrentRenderStage | ( |  | ) |

inline

References _currentRenderBin.

Referenced by getCurrentCamera().

## getCurrentStateGraph()

StateGraph * osgUtil::CullVisitor::getCurrentStateGraph | ( |  | ) |

inline

References _currentStateGraph.

## getDistanceFromEyePoint()

virtual float osgUtil::CullVisitor::getDistanceFromEyePoint | ( | const osg::Vec3 & | ,
|  | bool | ) const

virtual

Get the distance of a point from the eye point, distance value in the eye coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented than a default value of 0.0 is returned.

Reimplemented from osg::NodeVisitor.

## getDistanceToEyePoint()

virtual float osgUtil::CullVisitor::getDistanceToEyePoint | ( | const osg::Vec3 & | ,
|  | bool | ) const

virtual

Get the distance from a point to the eye point, distance value in local coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented then a default value of 0.0 is returned.

Reimplemented from osg::NodeVisitor.

## getDistanceToViewPoint()

virtual float osgUtil::CullVisitor::getDistanceToViewPoint | ( | const osg::Vec3 & | ,
|  | bool | ) const

virtual

Get the distance from a point to the view point, distance value in local coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceToViewPoint(pos) is not implemented then a default value of 0.0 is returned.

Reimplemented from osg::NodeVisitor.

## getEyePoint()

virtual osg::Vec3 osgUtil::CullVisitor::getEyePoint | ( |  | ) | const

inline virtual

Get the eye point in local coordinates. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement.

Reimplemented from osg::NodeVisitor.

References osg::CullStack::getEyeLocal().

## getIdentifier() [1/2]

Identifier * osgUtil::CullVisitor::getIdentifier | ( |  | ) |

inline

References _identifier.

## getIdentifier() [2/2]

const Identifier * osgUtil::CullVisitor::getIdentifier | ( |  | ) | const

inline

References _identifier.

## getRenderInfo() [1/2]

osg::RenderInfo & osgUtil::CullVisitor::getRenderInfo | ( |  | ) |

inline

References _renderInfo.

## getRenderInfo() [2/2]

const osg::RenderInfo & osgUtil::CullVisitor::getRenderInfo | ( |  | ) | const

inline

References _renderInfo.

## getRenderStage()

RenderStage * osgUtil::CullVisitor::getRenderStage | ( |  | ) |

inline

References _rootRenderStage.

## getRootStateGraph()

StateGraph * osgUtil::CullVisitor::getRootStateGraph | ( |  | ) |

inline

References _rootStateGraph.

## getState() [1/2]

osg::State * osgUtil::CullVisitor::getState | ( |  | ) |

inline

References _renderInfo.

## getState() [2/2]

const osg::State * osgUtil::CullVisitor::getState | ( |  | ) | const

inline

References _renderInfo.

## getViewPoint()

virtual osg::Vec3 osgUtil::CullVisitor::getViewPoint | ( |  | ) | const

inline virtual

Get the view point in local coordinates. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement.

Reimplemented from osg::NodeVisitor.

References osg::CullStack::getViewPointLocal().

## handle_cull_callbacks_and_accept()

void osgUtil::CullVisitor::handle_cull_callbacks_and_accept | ( | osg::Node & | node,
|  | osg::Node * | acceptNode )

inline protected

References osg::Node::accept(), osg::Node::getCullCallback(), and osg::Callback::run().

## handle_cull_callbacks_and_traverse()

void osgUtil::CullVisitor::handle_cull_callbacks_and_traverse | ( | osg::Node & | node | ) |

inline protected

References osg::Node::getCullCallback(), osg::Callback::run(), and osg::NodeVisitor::traverse().

## META_NodeVisitor()

osgUtil::CullVisitor::META_NodeVisitor | ( | osgUtil | ,
|  | CullVisitor | )

inline

Convert 'this' into a osgUtil::CullVisitor pointer if Object is a osgUtil::CullVisitor, otherwise return 0. Equivalent to dynamic_cast<osgUtil::CullVisitor*>(this).

References asCullVisitor(), and CullVisitor().

## operator=()

CullVisitor & osgUtil::CullVisitor::operator= | ( | const CullVisitor & |  | ) |

inline protected

Prevent unwanted copy operator.

References CullVisitor().

## popProjectionMatrix()

virtual void osgUtil::CullVisitor::popProjectionMatrix | ( |  | ) |

virtual

Re-implement CullStack's popProjectionMatrix() adding clamping of the projection matrix to the computed near and far.

## popStateSet()

void osgUtil::CullVisitor::popStateSet | ( |  | ) |

inline

Pop the top state set and hence associated state group. Move the current state group to the parent of the popped state group.

References _currentRenderBin, _currentStateGraph, _numberOfEncloseOverrideRenderBinDetails, _renderBinStack, osg::StateSet::getBinName(), osg::StateSet::getRenderBinMode(), osg::StateSet::OVERRIDE_RENDERBIN_DETAILS, osg::StateSet::PROTECTED_RENDERBIN_DETAILS, and osg::StateSet::useRenderBinDetails().

## prototype()

osg::ref_ptr< CullVisitor > & osgUtil::CullVisitor::prototype | ( |  | ) |

static

get the prototype singleton used by CullVisitor::create().

## pushStateSet()

void osgUtil::CullVisitor::pushStateSet | ( | const osg::StateSet * | ss | ) |

inline

Push state set on the current state group. If the state exists in a child state group of the current state group then move the current state group to that child. Otherwise, create a new state group for the state set, add it to the current state group then move the current state group pointer to the new state group.

References _currentRenderBin, _currentStateGraph, _numberOfEncloseOverrideRenderBinDetails, _renderBinStack, osg::StateSet::getBinName(), osg::StateSet::getBinNumber(), osg::StateSet::getNestRenderBins(), osg::StateSet::getRenderBinMode(), osg::StateSet::OVERRIDE_RENDERBIN_DETAILS, osg::StateSet::PROTECTED_RENDERBIN_DETAILS, and osg::StateSet::useRenderBinDetails().

## reset()

virtual void osgUtil::CullVisitor::reset | ( |  | ) |

virtual

Method to call to reset visitor. Useful if your visitor accumulates state during a traversal, and you plan to reuse the visitor. To flush that state for the next traversal: call reset() prior to each traversal.

Reimplemented from osg::NodeVisitor.

## setCalculatedFarPlane()

void osgUtil::CullVisitor::setCalculatedFarPlane | ( | value_type | value | ) |

inline

References _computed_zfar.

## setCalculatedNearPlane()

void osgUtil::CullVisitor::setCalculatedNearPlane | ( | value_type | value | ) |

inline

References _computed_znear.

## setCurrentRenderBin()

void osgUtil::CullVisitor::setCurrentRenderBin | ( | RenderBin * | rb | ) |

inline

References _currentRenderBin.

## setIdentifier()

void osgUtil::CullVisitor::setIdentifier | ( | Identifier * | identifier | ) |

inline

References _identifier.

## setRenderInfo()

void osgUtil::CullVisitor::setRenderInfo | ( | osg::RenderInfo & | renderInfo | ) |

inline

References _renderInfo.

## setRenderStage()

void osgUtil::CullVisitor::setRenderStage | ( | RenderStage * | rg | ) |

inline

References _currentRenderBin, and _rootRenderStage.

## setState()

void osgUtil::CullVisitor::setState | ( | osg::State * | state | ) |

inline

References _renderInfo.

## setStateGraph()

void osgUtil::CullVisitor::setStateGraph | ( | StateGraph * | rg | ) |

inline

References _currentStateGraph, and _rootStateGraph.

## updateCalculatedNearFar() [1/3]

bool osgUtil::CullVisitor::updateCalculatedNearFar | ( | const osg::Matrix & | matrix,
|  | const osg::BoundingBox & | bb )

## updateCalculatedNearFar() [2/3]

bool osgUtil::CullVisitor::updateCalculatedNearFar | ( | const osg::Matrix & | matrix,
|  | const osg::Drawable & | drawable,
|  | bool | isBillboard = false )

## updateCalculatedNearFar() [3/3]

void osgUtil::CullVisitor::updateCalculatedNearFar | ( | const osg::Vec3 & | pos | ) |

References addDrawable(), addDrawableAndDepth(), addPositionedAttribute(), and addPositionedTextureAttribute().

## Member Data Documentation

## _computed_zfar

value_type osgUtil::CullVisitor::_computed_zfar

protected

Referenced by getCalculatedFarPlane(), and setCalculatedFarPlane().

## _computed_znear

value_type osgUtil::CullVisitor::_computed_znear

protected

Referenced by getCalculatedNearPlane(), and setCalculatedNearPlane().

## _currentRenderBin

RenderBin* osgUtil::CullVisitor::_currentRenderBin

protected

Referenced by addDrawable(), addDrawableAndDepth(), addPositionedAttribute(), addPositionedTextureAttribute(), getCurrentRenderBin(), getCurrentRenderStage(), popStateSet(), pushStateSet(), setCurrentRenderBin(), and setRenderStage().

## _currentReuseRenderLeafIndex

unsigned int osgUtil::CullVisitor::_currentReuseRenderLeafIndex

protected

Referenced by createOrReuseRenderLeaf().

## _currentStateGraph

StateGraph* osgUtil::CullVisitor::_currentStateGraph

protected

Referenced by addDrawable(), addDrawableAndDepth(), getCurrentStateGraph(), popStateSet(), pushStateSet(), and setStateGraph().

## _farPlaneCandidateMap

DistanceMatrixDrawableMap osgUtil::CullVisitor::_farPlaneCandidateMap

protected

## _identifier

osg::ref_ptr<Identifier> osgUtil::CullVisitor::_identifier

protected

Referenced by getIdentifier(), getIdentifier(), and setIdentifier().

## _nearPlaneCandidateMap

DistanceMatrixDrawableMap osgUtil::CullVisitor::_nearPlaneCandidateMap

protected

## _numberOfEncloseOverrideRenderBinDetails

unsigned int osgUtil::CullVisitor::_numberOfEncloseOverrideRenderBinDetails

protected

Referenced by popStateSet(), and pushStateSet().

## _renderBinStack

std::vector<RenderBin*> osgUtil::CullVisitor::_renderBinStack

protected

Referenced by popStateSet(), and pushStateSet().

## _renderInfo

osg::RenderInfo osgUtil::CullVisitor::_renderInfo

protected

Referenced by getRenderInfo(), getRenderInfo(), getState(), getState(), setRenderInfo(), and setState().

## _reuseRenderLeafList

RenderLeafList osgUtil::CullVisitor::_reuseRenderLeafList

protected

Referenced by createOrReuseRenderLeaf().

## _rootRenderStage

osg::ref_ptr<RenderStage> osgUtil::CullVisitor::_rootRenderStage

protected

Referenced by getRenderStage(), and setRenderStage().

## _rootStateGraph

osg::ref_ptr<StateGraph> osgUtil::CullVisitor::_rootStateGraph

protected

Referenced by getRootStateGraph(), and setStateGraph().

## _traversalOrderNumber

unsigned int osgUtil::CullVisitor::_traversalOrderNumber

protected

Referenced by createOrReuseRenderLeaf().

The documentation for this class was generated from the following file:

- CullVisitor